// minified with http://closure-compiler.appspot.com/home
// local: CTRL+SHIFT+C

jQuery( document ).ready( function() {
	jQuery( 'body.football-pool input.current-page' ).keydown( function( e ) {
		var code = ( e.keyCode ? e.keyCode : e.which );
		if ( code == 13 ) jQuery( 'input[name="action"]' ).val( '' );
	} );
	
	jQuery( 'div.matchtype input:checkbox' ).click( function() {
		var matchtype_id = jQuery( this ).attr( 'id' ).replace( 'matchtype-', '' );
		if ( jQuery( this ).is( ':checked' ) ) {
			jQuery( 'div.matchtype-' + matchtype_id + ' input:checkbox' ).each( function() {
				jQuery( this ).attr( 'checked', 'checked' );
			} );
		} else {
			jQuery( 'div.matchtype-' + matchtype_id + ' input:checkbox' ).each( function() {
				jQuery( this ).removeAttr( 'checked' );
			} );
		}
	} );
	
	// show/hide row actions on tab navigation
	jQuery( 'div.row-actions span a' ).each( function() {
		jQuery( this ).focus( { el: jQuery( this ) }, function( e ) {
			jQuery( window ).keyup( { el: e.data.el }, function( e ) {
				var code = ( e.keyCode ? e.keyCode : e.which );
				if ( code == 9 ) {
					e.data.el.parent().parent().css( { left: 0 } ); 
				}
			} );
		} );
		jQuery( this ).blur( { el: jQuery( this ) }, function( e ) {
			jQuery( window ).keyup( { el: e.data.el }, function( e ) {
				var code = ( e.keyCode ? e.keyCode : e.which );
				if ( code == 9 ) {
					e.data.el.parent().parent().css( { left: -9999 } ); 
				}
			} );
		} );
	} );
} );

var FootballPoolAdmin = (function ( $ ) {
	
	var value_store = [];
	
	// tinymce extension
	function tinymce_init_tabs( id ) {
		$( 'li', '#' + id ).each( function() {
			$( this ).bind( "click", function() {
				mcTabs.displayTab( 
									$( this ).attr( 'id' ), 
									$( this ).attr( 'id' ).replace( '_tab', '' ) + '_panel'
								);
				return false;
			})
		});
	}

	function tinymce_init() {
		tinyMCEPopup.resizeToInnerSize();
	}

	function tinymce_insert_shortcode() {
		var selected_val, 
			shortcode = '', 
			close_tag = false,
			content = false,
			preserve_content = false;
			the_text = '',
			panel = '',
			atts = '';
		
		// determine which panel was selected
		$( 'div', '#panel_wrapper' ).each( function() { 
			if ( $( this ).hasClass( 'current' ) ) panel = $( this ).attr( 'id' );
		});
		
		var panel_id = '#' + panel;
		
		selected_val = $( '.shortcode', panel_id ).val();
		switch( selected_val ) {
			case 'fp-link':
				var slug = $( '#slug', panel_id ).val();
				if ( slug != '' ) atts += ' slug="' + slug + '"';
				break;
			case 'fp-register':
				preserve_content = true;
				close_tag = true;
				var title = $( '#link-title', panel_id ).val();
				if ( title != '' ) atts += ' title="' + title + '"';
				var new_window = $( '#link-window', panel_id ).is( ':checked' );
				if ( new_window ) atts += ' new="1"';
				break;
			case 'fp-countdown':
				var count_to = $( 'input[name=count_to]:checked', panel_id ).val();
				if ( count_to == 'date' ) {
					var the_date = $( '#count-date', panel_id ).val();
					if ( the_date != '' ) atts += ' date="' + the_date + '"';
				} else if ( count_to == 'match' ) {
					var match = $( '#count-match', panel_id ).val();
					if ( match > 0 || match == 'next' ) atts += ' match="' + match + '"';
				}
				var inline = $( '#count-inline', panel_id ).is( ':checked' );
				if ( inline ) atts += ' display="inline"';
				var no_texts = $( '#count-no-texts', panel_id ).is( ':checked' );
				var texts = '';
				if ( no_texts ) {
					texts = 'none';
				} else {
					texts = [ $( '#text-1', panel_id ).val(), $( '#text-2', panel_id ).val(), $( '#text-3', panel_id ).val(), $( '#text-4', panel_id ).val() ].join( ';' );
				}
				if ( texts != '' && texts != ';;;' ) atts += ' texts="' + texts + '"';
				var time_format = $( '#count-format', panel_id ).val();
				if ( time_format > 0 ) atts += ' format="' + time_format + '"';
				break;
			case 'fp-group':
				var group = $( '#group-id', panel_id ).val();
				if ( group > 0 ) atts += ' id=' + group;
				break;
			case 'fp-ranking':
				var ranking = $( '#ranking-id', panel_id ).val();
				if ( ranking > 0 ) atts += ' ranking="' + ranking + '"';
				var league = $( '#ranking-league', panel_id ).val();
				if ( league > 0 ) atts += ' league="' + league + '"';
				var num = $( '#ranking-num', panel_id ).val();
				if ( num > 0 ) atts += ' num="' + num + '"';
				var date = $( 'input:radio[name=ranking-date]:checked', panel_id ).val();
				if ( date == 'custom' ) date = $( '#ranking-date-custom-value', panel_id ).val();
				if ( date != '' ) atts += ' date="' + date + '"';
				break;
			case 'fp-predictions':
				var match = $( '#predictions-match', panel_id ).val();
				if ( match > 0 ) atts += ' match="' + match + '"';
				var question = $( '#predictions-question', panel_id ).val();
				if ( question > 0 ) atts += ' question="' + question + '"';
				var text = $( '#predictions-text', panel_id ).val();
				if ( text != '' ) atts += ' text="' + text + '"';
				break;
			case 'fp-user-score':
				var ranking = $( '#user-score-ranking-id', panel_id ).val();
				if ( ranking > 0 ) atts += ' ranking="' + ranking + '"';
				var user = $( '#user-score-user-id', panel_id ).val();
				if ( user != '' ) atts += ' user="' + user + '"';
				var text = $( '#user-score-text', panel_id ).val();
				if ( text != '' ) atts += ' text="' + text + '"';
				var date = $( 'input:radio[name=user-score-date]:checked', panel_id ).val();
				if ( date == 'custom' ) date = $( '#user-score-date-custom-value', panel_id ).val();
				if ( date != '' ) atts += ' date="' + date + '"';
				break;
			case 'fp-user-ranking':
				var ranking = $( '#user-ranking-ranking-id', panel_id ).val();
				if ( ranking > 0 ) atts += ' ranking="' + ranking + '"';
				var user = $( '#user-ranking-user-id', panel_id ).val();
				if ( user != '' ) atts += ' user="' + user + '"';
				var text = $( '#user-ranking-text', panel_id ).val();
				if ( text != '' ) atts += ' text="' + text + '"';
				var date = $( 'input:radio[name=user-ranking-date]:checked', panel_id ).val();
				if ( date == 'custom' ) date = $( '#user-ranking-date-custom-value', panel_id ).val();
				if ( date != '' ) atts += ' date="' + date + '"';
				break;
			case 'fp-predictionform':
				var matches = $( '#match-id', panel_id ).val() || [];
				if ( matches.length > 0 ) atts += ' match="' + matches.join( ',' ) + '"';
				var matchtypes = $( '#matchtype-id', panel_id ).val() || [];
				if ( matchtypes.length > 0 ) atts += ' matchtype="' + matchtypes.join( ',' ) + '"';
				var questions = $( '#question-id', panel_id ).val() || [];
				if ( questions.length > 0 ) atts += ' question="' + questions.join( ',' ) + '"';
				break;
			case 'fp-matches':
				var group_id = $( '#matches-group-id', panel_id ).val();
				if ( group_id != '' ) atts += ' group="' + group_id + '"';
				var matches = $( '#matches-match-id', panel_id ).val() || [];
				if ( matches.length > 0 ) atts += ' match="' + matches.join( ',' ) + '"';
				var matchtypes = $( '#matches-matchtype-id', panel_id ).val() || [];
				if ( matchtypes.length > 0 ) atts += ' matchtype="' + matchtypes.join( ',' ) + '"';
				break;
			case 'fp-next-matches':
				var group_id = $( '#next-matches-group-id', panel_id ).val();
				if ( group_id != '' ) atts += ' group="' + group_id + '"';
				var matchtypes = $( '#next-matches-matchtype-id', panel_id ).val() || [];
				if ( matchtypes.length > 0 ) atts += ' matchtype="' + matchtypes.join( ',' ) + '"';
				var date = $( 'input:radio[name=next-matches-date]:checked', panel_id ).val();
				if ( date == 'custom' ) date = $( '#next-matches-date-custom-value', panel_id ).val();
				if ( date != '' ) atts += ' date="' + date + '"';
				var num = $( '#next-matches-num', panel_id ).val();
				if ( num > 0 ) atts += ' num="' + num + '"';
				break;
			case 'fp-league-info':
				var league_id = $( '#league-info-league-id', panel_id ).val();
				if ( league_id > 0 ) atts += ' league="' + league_id + '"';
				var info = $( 'input:radio[name=league-info-info]:checked', panel_id ).val();
				if ( info != '' ) atts += ' info="' + info + '"';
				var ranking_id = $( '#league-info-ranking-id', panel_id ).val();
				if ( ranking_id > 0 ) atts += ' ranking="' + ranking_id + '"';
				var format = $( '#league-info-format', panel_id ).val();
				if ( format != '' ) atts += ' format="' + format + '"';
				break;
			default:
				if ( selected_val == '' ) tinyMCEPopup.close();
		}
		
		if ( selected_val != '' ) {
			if ( preserve_content && tinyMCE.activeEditor.selection.getContent() != '' ) {
				the_text = tinyMCE.activeEditor.selection.getContent( { format : 'text' } );
			}
			shortcode  = '[' + selected_val + atts + ']';
			shortcode += the_text;
			shortcode += ( close_tag ? '[/' + selected_val + ']' : '' );
		}
		
		if ( window.tinyMCE ) {
			window.tinyMCE.execCommand( 'mceInsertContent', 0, shortcode );
			//Peforms a clean up of the current editor HTML.
			//tinyMCEPopup.editor.execCommand( 'mceCleanup' );
			//Repaints the editor. Sometimes the browser has graphic glitches.
			tinyMCEPopup.editor.execCommand( 'mceRepaint' );
			tinyMCEPopup.close();
		}
		return;
	}
	// end tinymce extension
	
	// score calculation handling
	var cbox;
	var start_time;
	var calc_timer = false;
	var force_calculation_setting = 0;
	var calculation_completed = false;
	var calculation_cancelled = false;
	
	function force_calculation() {
		force_calculation_setting = 1;
		calculate_score_history();
	}
	
	function cancel_calculation() {
		if ( ! calculation_completed ) {
			var ajax_action = 'footballpool_calculate_scorehistory';
			calculation_cancelled = true;
			
			$.ajax( {
					data: {
						action: ajax_action,
						fp_recalc_nonce: FootballPoolAjax.fp_recalc_nonce,
						calculation_step: 'cancel_calculation',
						iteration: 1
					},
					url: ajaxurl,
					global: false,
					dataType: 'json',
					method: 'POST',
					success: function( data, textStatus, jqXHR ) {
						console.log( 'football pool calculation cancelled' );
					},
					error: function( jqXHR, textStatus, errorThrown ) {
						console.log( errorThrown );
					}
			} );
		}
	}
	
	function calculate_score_history() {
		var data = arguments[0] || 0;
		var ajax_action = 'footballpool_calculate_scorehistory';
		var bar = [];
		
		if ( data === 0 ) {
			calculation_cancelled = false;
			start_time = new Date().getTime();
			
			$.ajax( {
					data: {
						action: ajax_action,
						fp_recalc_nonce: FootballPoolAjax.fp_recalc_nonce,
						iteration: 0,
						force_calculation: force_calculation_setting
					},
					url: ajaxurl,
					global: false,
					dataType: 'json',
					method: 'POST',
					success: function( response, textStatus, jqXHR ) {
								cbox = $.colorbox( { 
													html: response.colorbox_html,
													overlayClose: false,
													escKey: true,
													arrowKey: false,
													close: FootballPoolAjax.colorbox_close,
													innerWidth: "500px",
													innerHeight: "285px"
												} );
								// bind cleanup method to colorbox
								$( document ).bind( 'cbox_cleanup', function() {
									cancel_calculation();
								} );
								$( '#progress' ).show();
								bar = $( '#progressbar' );
								if ( bar.length != 0 ) {
									bar.progressbar();
									bar.show();
									$( '#ajax-loader' ).show();
									if ( bar.progressbar( 'option', 'max' ) != response.total_iterations ) {
										bar.progressbar( 'option', 'max', response.total_iterations );
									}
								}
								$( '#calculation-message' ).html( response.message );
								if ( ! calculation_cancelled ) calculate_score_history( response );
					},
					error: function( jqXHR, textStatus, errorThrown ) {
								clear_elapsed_time_timer();
								alert( "Error message:\n" + errorThrown ); 
					}
			} );
		} else {
			if ( calc_timer === false ) {
				calc_timer = setInterval( function() { 
											var elapsed_time = ( new Date().getTime() ) - start_time; 
											$( '#time-elapsed' ).html( format_time( elapsed_time / 1000 ) );
										}, 1000 );
			}
			
			$.ajax( {
					data: {
						action: ajax_action,
						force_calculation: data.force_calculation,
						fp_recalc_nonce: data.fp_recalc_nonce,
						total_iterations: data.total_iterations,
						iteration: data.iteration,
						sub_iteration: data.sub_iteration,
						sub_iterations: data.sub_iterations,
						calculation_step: data.calculation_step,
						user: data.user,
						ranking: data.ranking,
						match: data.match,
						question: data.question,
						prev_total_score: data.prev_total_score,
						score_order: data.score_order
					},
					url: ajaxurl,
					global: false,
					dataType: 'json',
					method: 'POST',
					success: function( response, textStatus, jqXHR ) {
								// console.log( response );
								if ( response == null ) {
									score_calculation_error( FootballPoolAdmin.error_message + ' Error: response was null.' );
								} else {
									calculation_completed = ( typeof response.completed !== 'undefined' 
																	&& response.completed === 1 );
									
									// calculate estimated time left
									var elapsed_time = ( new Date().getTime() ) - start_time;
									var iteration_time = elapsed_time / data.iteration;
									var estimated_total_time = data.total_iterations * iteration_time;
									var time_left_in_seconds = ( estimated_total_time - elapsed_time ) / 1000;
									if ( time_left_in_seconds < 0 ) time_left_in_seconds = 0;
									// only show time left when at least 2 iterations have passed
									if ( data.iteration > 1 ) {
										$( '#time-left' ).html( format_time( time_left_in_seconds ) );
									}
									// update progress bar and status message
									bar = $( '#progressbar' );
									if ( bar.length != 0 ) {
										bar.progressbar();
										if ( bar.progressbar( 'option', 'max' ) != response.total_iterations ) {
											bar.progressbar( 'option', 'max', response.total_iterations );
										}
										bar.progressbar( 'option', 'value', response.iteration );
									}
									$( '#calculation-message' ).html( response.message );
									
									// continue or stop?
									if ( response.error === false ) {
										if ( calculation_completed ) {
											clear_elapsed_time_timer();
											$( '#time-left' ).html( format_time( 0 ) );
											$( '#ajax-loader' ).hide();
										} else {
											if ( ! calculation_cancelled ) calculate_score_history( response );
										}
									} else {
										clear_elapsed_time_timer();
										score_calculation_error( response.error );
									}
								}
					},
					error: function( jqXHR, textStatus, errorThrown ) {
						score_calculation_error( errorThrown );
					}
			} );
		}
	}
	
	function format_time( sec_num ) {
		sec_num = Math.floor( sec_num );
		var hours   = Math.floor( sec_num / 3600 );
		var minutes = Math.floor( ( sec_num - ( hours * 3600 ) ) / 60 );
		var seconds = sec_num - ( hours * 3600 ) - ( minutes * 60 );

		if ( hours   < 10 ) hours   = '0' + hours;
		if ( minutes < 10 ) minutes = '0' + minutes;
		if ( seconds < 10 ) seconds = '0' + seconds;
		var time = hours + ':' + minutes + ':' + seconds;
		return time;
	}
	
	function clear_elapsed_time_timer() {
		clearInterval( calc_timer );
		calc_timer = false;
	}
	
	function score_calculation_error() {
		var msg = arguments[0] || FootballPoolAjax.error_message;
		clear_elapsed_time_timer();
		$( '#ajax-loader' ).hide();
		$( '#progress' ).show();
		$( '#calculation-message' ).html( '<span class="error">' + msg + '</span>' );
	}
	// end score calculation handler
	
	function bulk_action_warning( id ) {
		var bulk_select = $( '#' + id );
		var msg;
		if ( bulk_select && bulk_select.prop( 'selectedIndex' ) != 0 ) {
			msg = $( '#' + id + ' option').filter( ':selected' ).attr( 'bulk-msg' );
			if ( msg != '' && msg != undefined ) {
				return( confirm( msg ) );
			} else {
				return true;
			}
		} else {
			return false;
		}
	}

	function toggle_points( id ) {
		$( '#' + id + '_points' ).toggle();
	}
	
	function set_input_param( param, id, value ) {
		var param_value;
		if ( $.isArray( id ) && id.length >= 1 ) {
			$.each( id, function( i, v ) { 
				if ( v != '' ) {
					if ( ! $.isArray( value_store[v] ) ) value_store[v] = [];
					value_store[v][param] = $( v ).attr( param );
					param_value = $.isArray( value ) ? value[i] : value;
					$( v ).attr( param, param_value );
				}
			} );
		} else {
			if ( id != '' ) {
				value_store[id] = [ param, $( id ).attr( param ) ];
				param_value = $.isArray( value ) ? value[0] : value;
				$( id ).attr( param, param_value );
			}
		}
	}

	function restore_input_param( param, id ) {
		var param_value = '';
		if ( $.isArray( id ) && id.length >= 1 ) {
			$.each( id, function( i, v ) {
				param_value = ( typeof value_store[v][param] != undefined ) ? value_store[v][param] : '';
				$( v ).attr( param, param_value );
			} );
		} else {
			if ( id != '' ) {
				param_value = ( typeof value_store[id][param] != undefined ) ? value_store[id][param] : '';
				$( id ).attr( param, param_value );
			}
		}
	}
	
	function disable_inputs( id ) {
		var check_id = arguments[1] || '';
		var readonly = false;
		if ( check_id != '' ) {
			readonly = $( '#' + check_id ).is( ':checked' );
		}
		
		if ( $.isArray( id ) && id.length >= 1 ) {
			$.each( id, function( i, v ) { 
				if ( v != '' ) {
					if ( check_id != '' ) {
						if ( readonly ) {
							$( v ).attr( 'disabled', 'disabled' );
						} else {
							$( v ).removeAttr( 'disabled' );
						}
					} else {
						$( v ).attr( 'disabled', 'disabled' ); 
					}
				}
			} );
		} else if ( id != '' ) {
			if ( check_id != '' ) {
				if ( readonly ) {
					$( id ).attr( 'disabled', 'disabled' );
				} else {
					$( id ).removeAttr( 'disabled' );
				}
			} else {
				$( id ).attr( 'disabled', 'disabled' ); 
			}
		}
	}

	function toggle_linked_radio_options( active_id, disabled_id ) {
		if ( $.isArray( active_id ) && active_id.length >= 1 ) {
			$.each( active_id, function( i, v ) { 
				if ( v != '' ) $( v ).toggle( true ); 
			} );
		} else if ( active_id != '' ) {
			$( active_id ).toggle( true );
		}
		
		if ( $.isArray( disabled_id ) && disabled_id.length >= 1 ) {
			$.each( disabled_id, function( i, v ) { 
				if ( v != '' ) $( v ).toggle( false ); 
			} );
		} else if ( disabled_id != '' ) {
			$( disabled_id ).toggle( false );
		}
	}
	
	return {
		// public methods
		tinymce_init: tinymce_init,
		tinymce_init_tabs: tinymce_init_tabs,
		tinymce_insert_shortcode: tinymce_insert_shortcode,
		calculate: calculate_score_history,
		force_calculation: force_calculation,
		bulk_action_warning: bulk_action_warning,
		toggle_points: toggle_points,
		set_input_param: set_input_param,
		restore_input_param: restore_input_param,
		disable_inputs: disable_inputs,
		toggle_linked_options: toggle_linked_radio_options
	};

} )( jQuery );

// jQuery Input Hints plugin
// Copyright (c) 2009 Rob Volk
// http://www.robvolk.com

jQuery( document ).ready( function() {
   jQuery( 'input[title].with-hint' ).inputHints();
});

jQuery.fn.inputHints=function() {
	// hides the input display text stored in the title on focus
	// and sets it on blur if the user hasn't changed it.

	// show the display text
	// changed (AntoineH): only for empty inputs
	jQuery(this).each(function(i) {
		if (jQuery(this).val() == '') {
			jQuery(this).val(jQuery(this).attr('title'))
				.addClass('hint');
		}
	});

	// hook up the blur & focus
	return jQuery(this).focus(function() {
		if (jQuery(this).val() == jQuery(this).attr('title'))
			jQuery(this).val('')
				.removeClass('hint');
	}).blur(function() {
		if (jQuery(this).val() == '')
			jQuery(this).val(jQuery(this).attr('title'))
				.addClass('hint');
	});
}; // jQuery Input Hints plugin
